Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.beanutils
Class MethodUtils

    java.lang.Object
      |
      +--org.apache.commons.beanutils.MethodUtils

public class MethodUtils
extends java.lang.Object

Utility reflection methods focussed on methods in general rather than properties in particular.

### Known Limitations

#### Accessing Public Methods In A Default Access Superclass

There is an issue when invoking public methods contained in a default access superclass. Reflection locates these methods fine and correctly assigns them as public. However, an `IllegalAccessException` is thrown if the method is invoked.

`MethodUtils` contains a workaround for this situation. It will attempt to call `setAccessible` on this method. If this call succeeds, then the method can be invoked as normal. This call will only succeed when the application has sufficient security privilages. If this call fails then a warning will be logged and the method may fail.

Author:
  Craig R. McClanahan, Ralph Schaer, Chris Audley, Rey François, Gregor Raýman, Jan Sorensen, Robert Burrell Donkin

Constructor Summary
`MethodUtils()`

Method Summary
`static java.lang.reflect.Method` | `getAccessibleMethod(java.lang.Class clazz, java.lang.String methodName, java.lang.Class parameterType)` Return an accessible method (that is, one that can be invoked via reflection) with given name and a single parameter.
`static java.lang.reflect.Method` | `getAccessibleMethod(java.lang.Class clazz, java.lang.String methodName, java.lang.Class[] parameterTypes)` Return an accessible method (that is, one that can be invoked via reflection) with given name and parameters.
`static java.lang.reflect.Method` | `getAccessibleMethod(java.lang.reflect.Method method)` Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method.
`static java.lang.reflect.Method` | `getMatchingAccessibleMethod(java.lang.Class clazz, java.lang.String methodName, java.lang.Class[] parameterTypes)` Find an accessible method that matches the given name and has compatible parameters.
`static java.lang.Class` | `getPrimitiveType(java.lang.Class wrapperType)` Gets the class for the primitive type corresponding to the primitive wrapper class given.
`static java.lang.Class` | `getPrimitiveWrapper(java.lang.Class primitiveType)` Gets the wrapper object class for the given primitive type class.
`static java.lang.Object` | `invokeExactMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object arg)` Invoke a method whose parameter type matches exactly the object type.
`static java.lang.Object` | `invokeExactMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object[] args)` Invoke a method whose parameter types match exactly the object types.
`static java.lang.Object` | `invokeExactMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object[] args, java.lang.Class[] parameterTypes)` Invoke a method whose parameter types match exactly the parameter types given.
`static java.lang.Object` | `invokeExactStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object arg)` Invoke a static method whose parameter type matches exactly the object type.
`static java.lang.Object` | `invokeExactStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object[] args)` Invoke a static method whose parameter types match exactly the object types.
`static java.lang.Object` | `invokeExactStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object[] args, java.lang.Class[] parameterTypes)` Invoke a static method whose parameter types match exactly the parameter types given.
`static java.lang.Object` | `invokeMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object arg)` Invoke a named method whose parameter type matches the object type.
`static java.lang.Object` | `invokeMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object[] args)` Invoke a named method whose parameter type matches the object type.
`static java.lang.Object` | `invokeMethod(java.lang.Object object, java.lang.String methodName, java.lang.Object[] args, java.lang.Class[] parameterTypes)` Invoke a named method whose parameter type matches the object type.
`static java.lang.Object` | `invokeStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object arg)` Invoke a named static method whose parameter type matches the object type.
`static java.lang.Object` | `invokeStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object[] args)` Invoke a named static method whose parameter type matches the object type.
`static java.lang.Object` | `invokeStaticMethod(java.lang.Class objectClass, java.lang.String methodName, java.lang.Object[] args, java.lang.Class[] parameterTypes)` Invoke a named static method whose parameter type matches the object type.
`static boolean` | `isAssignmentCompatible(java.lang.Class parameterType, java.lang.Class parameterization)` Determine whether a type can be used as a parameter in a method invocation.
`static java.lang.Class` | `toNonPrimitiveClass(java.lang.Class clazz)` Find a non primitive representation for given primitive class.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MethodUtils

    public MethodUtils()

Method Detail

### invokeMethod

    public static java.lang.Object invokeMethod(java.lang.Object object,
                                                java.lang.String methodName,
                                                java.lang.Object arg)
                                         throws java.lang.NoSuchMethodException,
                                                java.lang.IllegalAccessException,
                                                java.lang.reflect.InvocationTargetException

  Invoke a named method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactMethod()`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  This is a convenient wrapper for `invokeMethod(Object object,String methodName,Object [] args)`.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `arg` - use this argument
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeMethod

    public static java.lang.Object invokeMethod(java.lang.Object object,
                                                java.lang.String methodName,
                                                java.lang.Object[] args)
                                         throws java.lang.NoSuchMethodException,
                                                java.lang.IllegalAccessException,
                                                java.lang.reflect.InvocationTargetException

  Invoke a named method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args)`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  This is a convenient wrapper for `invokeMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeMethod

    public static java.lang.Object invokeMethod(java.lang.Object object,
                                                java.lang.String methodName,
                                                java.lang.Object[] args,
                                                java.lang.Class[] parameterTypes)
                                         throws java.lang.NoSuchMethodException,
                                                java.lang.IllegalAccessException,
                                                java.lang.reflect.InvocationTargetException

  Invoke a named method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
    `parameterTypes` - match these parameters - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactMethod

    public static java.lang.Object invokeExactMethod(java.lang.Object object,
                                                     java.lang.String methodName,
                                                     java.lang.Object arg)
                                              throws java.lang.NoSuchMethodException,
                                                     java.lang.IllegalAccessException,
                                                     java.lang.reflect.InvocationTargetException

  Invoke a method whose parameter type matches exactly the object type.

  This is a convenient wrapper for `invokeExactMethod(Object object,String methodName,Object [] args)`.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `arg` - use this argument
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactMethod

    public static java.lang.Object invokeExactMethod(java.lang.Object object,
                                                     java.lang.String methodName,
                                                     java.lang.Object[] args)
                                              throws java.lang.NoSuchMethodException,
                                                     java.lang.IllegalAccessException,
                                                     java.lang.reflect.InvocationTargetException

  Invoke a method whose parameter types match exactly the object types.

  This uses reflection to invoke the method obtained from a call to `getAccessibleMethod()`.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactMethod

    public static java.lang.Object invokeExactMethod(java.lang.Object object,
                                                     java.lang.String methodName,
                                                     java.lang.Object[] args,
                                                     java.lang.Class[] parameterTypes)
                                              throws java.lang.NoSuchMethodException,
                                                     java.lang.IllegalAccessException,
                                                     java.lang.reflect.InvocationTargetException

  Invoke a method whose parameter types match exactly the parameter types given.

  This uses reflection to invoke the method obtained from a call to `getAccessibleMethod()`.

  Parameters:
    `object` - invoke method on this object
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
    `parameterTypes` - match these parameters - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactStaticMethod

    public static java.lang.Object invokeExactStaticMethod(java.lang.Class objectClass,
                                                           java.lang.String methodName,
                                                           java.lang.Object[] args,
                                                           java.lang.Class[] parameterTypes)
                                                    throws java.lang.NoSuchMethodException,
                                                           java.lang.IllegalAccessException,
                                                           java.lang.reflect.InvocationTargetException

  Invoke a static method whose parameter types match exactly the parameter types given.

  This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
    `parameterTypes` - match these parameters - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeStaticMethod

    public static java.lang.Object invokeStaticMethod(java.lang.Class objectClass,
                                                      java.lang.String methodName,
                                                      java.lang.Object arg)
                                               throws java.lang.NoSuchMethodException,
                                                      java.lang.IllegalAccessException,
                                                      java.lang.reflect.InvocationTargetException

  Invoke a named static method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactMethod(Object, String, Object[], Class[])`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  This is a convenient wrapper for `invokeStaticMethod(Class objectClass,String methodName,Object [] args)`.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `arg` - use this argument
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeStaticMethod

    public static java.lang.Object invokeStaticMethod(java.lang.Class objectClass,
                                                      java.lang.String methodName,
                                                      java.lang.Object[] args)
                                               throws java.lang.NoSuchMethodException,
                                                      java.lang.IllegalAccessException,
                                                      java.lang.reflect.InvocationTargetException

  Invoke a named static method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactMethod(Object object,String methodName,Object [] args)`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  This is a convenient wrapper for `invokeStaticMethod(Class objectClass,String methodName,Object [] args,Class[] parameterTypes)`.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeStaticMethod

    public static java.lang.Object invokeStaticMethod(java.lang.Class objectClass,
                                                      java.lang.String methodName,
                                                      java.lang.Object[] args,
                                                      java.lang.Class[] parameterTypes)
                                               throws java.lang.NoSuchMethodException,
                                                      java.lang.IllegalAccessException,
                                                      java.lang.reflect.InvocationTargetException

  Invoke a named static method whose parameter type matches the object type.

  The behaviour of this method is less deterministic than `invokeExactStaticMethod(Class objectClass,String methodName,Object [] args,Class[] parameterTypes)`. It loops through all methods with names that match and then executes the first it finds with compatable parameters.

  This method supports calls to methods taking primitive parameters via passing in wrapping classes. So, for example, a `Boolean` class would match a `boolean` primitive.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
    `parameterTypes` - match these parameters - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactStaticMethod

    public static java.lang.Object invokeExactStaticMethod(java.lang.Class objectClass,
                                                           java.lang.String methodName,
                                                           java.lang.Object arg)
                                                    throws java.lang.NoSuchMethodException,
                                                           java.lang.IllegalAccessException,
                                                           java.lang.reflect.InvocationTargetException

  Invoke a static method whose parameter type matches exactly the object type.

  This is a convenient wrapper for `invokeExactStaticMethod(Class objectClass,String methodName,Object [] args)`.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `arg` - use this argument
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### invokeExactStaticMethod

    public static java.lang.Object invokeExactStaticMethod(java.lang.Class objectClass,
                                                           java.lang.String methodName,
                                                           java.lang.Object[] args)
                                                    throws java.lang.NoSuchMethodException,
                                                           java.lang.IllegalAccessException,
                                                           java.lang.reflect.InvocationTargetException

  Invoke a static method whose parameter types match exactly the object types.

  This uses reflection to invoke the method obtained from a call to `getAccessibleMethod(Class, String, Class[])`.

  Parameters:
    `objectClass` - invoke static method on this class
    `methodName` - get method with this name
    `args` - use these arguments - treat null as empty array
  Returns:
    The value returned by the invoked method
  Throws:
    `java.lang.NoSuchMethodException` - if there is no such accessible method
    `java.lang.reflect.InvocationTargetException` - wraps an exception thrown by the method invoked
    `java.lang.IllegalAccessException` - if the requested method is not accessible via reflection

### getAccessibleMethod

    public static java.lang.reflect.Method getAccessibleMethod(java.lang.Class clazz,
                                                               java.lang.String methodName,
                                                               java.lang.Class parameterType)

  Return an accessible method (that is, one that can be invoked via reflection) with given name and a single parameter. If no such method can be found, return `null`. Basically, a convenience wrapper that constructs a `Class` array for you.

  Parameters:
    `clazz` - get method from this class
    `methodName` - get method with this name
    `parameterType` - taking this type of parameter
  Returns:
    The accessible method

### getAccessibleMethod

    public static java.lang.reflect.Method getAccessibleMethod(java.lang.Class clazz,
                                                               java.lang.String methodName,
                                                               java.lang.Class[] parameterTypes)

  Return an accessible method (that is, one that can be invoked via reflection) with given name and parameters. If no such method can be found, return `null`. This is just a convenient wrapper for `getAccessibleMethod(Method method)`.

  Parameters:
    `clazz` - get method from this class
    `methodName` - get method with this name
    `parameterTypes` - with these parameters types
  Returns:
    The accessible method

### getAccessibleMethod

    public static java.lang.reflect.Method getAccessibleMethod(java.lang.reflect.Method method)

  Return an accessible method (that is, one that can be invoked via reflection) that implements the specified Method. If no such method can be found, return `null`.

  Parameters:
    `method` - The method that we wish to call
  Returns:
    The accessible method

### getMatchingAccessibleMethod

    public static java.lang.reflect.Method getMatchingAccessibleMethod(java.lang.Class clazz,
                                                                       java.lang.String methodName,
                                                                       java.lang.Class[] parameterTypes)

  Find an accessible method that matches the given name and has compatible parameters. Compatible parameters mean that every method parameter is assignable from the given parameters. In other words, it finds a method with the given name that will take the parameters given.

  This method is slightly undeterminstic since it loops through methods names and return the first matching method.

  This method is used by `invokeMethod(Object object,String methodName,Object [] args,Class[] parameterTypes)`.

  This method can match primitive parameter by passing in wrapper classes. For example, a `Boolean` will match a primitive `boolean` parameter.

  Parameters:
    `clazz` - find method in this class
    `methodName` - find method with this name
    `parameterTypes` - find method with compatible parameters
  Returns:
    The accessible method

### isAssignmentCompatible

    public static final boolean isAssignmentCompatible(java.lang.Class parameterType,
                                                       java.lang.Class parameterization)

  Determine whether a type can be used as a parameter in a method invocation. This method handles primitive conversions correctly.

  In order words, it will match a `Boolean` to a `boolean`, a `Long` to a `long`, a `Float` to a `float`, a `Integer` to a `int`, and a `Double` to a `double`. Now logic widening matches are allowed. For example, a `Long` will not match a `int`.

  Parameters:
    `parameterType` - the type of parameter accepted by the method
    `parameterization` - the type of parameter being tested
  Returns:
    true if the assignement is compatible.

### getPrimitiveWrapper

    public static java.lang.Class getPrimitiveWrapper(java.lang.Class primitiveType)

  Gets the wrapper object class for the given primitive type class. For example, passing `boolean.class` returns `Boolean.class`
  Parameters:
    `primitiveType` - the primitive type class for which a match is to be found
  Returns:
    the wrapper type associated with the given primitive or null if no match is found

### getPrimitiveType

    public static java.lang.Class getPrimitiveType(java.lang.Class wrapperType)

  Gets the class for the primitive type corresponding to the primitive wrapper class given. For example, an instance of `Boolean.class` returns a `boolean.class`.
  Parameters:
    `wrapperType` - the
  Returns:
    the primitive type class corresponding to the given wrapper class, null if no match is found

### toNonPrimitiveClass

    public static java.lang.Class toNonPrimitiveClass(java.lang.Class clazz)

  Find a non primitive representation for given primitive class.
  Parameters:
    `clazz` - the class to find a representation for, not null
  Returns:
    the original class if it not a primitive. Otherwise the wrapper class. Not null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 The Apache Software Foundation. All Rights Reserved.